#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/stat.h>

int main(int argc, char **argv)
{
	struct stat fileinfo;
	FILE *file_stream = NULL;
	
	if(argc <= 2) {
		fprintf(stderr, "Usage: %s [file] [message]\n");
		exit(1);
	}

	if(stat(argv[1], &fileinfo)) {
		fprintf(stderr, "Error stat on file %s\n", argv[1]);
		exit(1);
	}

	if(fileinfo.st_uid != getuid()) {
		fprintf(stderr, "You must specify the file of your own file.\n");
		exit(1);
	}

	sleep(10);

	if((file_stream = fopen(argv[1], "a+")) == NULL) {
		fprintf(stderr, "Error opening %s for writing.\n", argv[1]);
		exit(1);
	}

	fprintf(file_stream, "%s\n", argv[2]);
	
	fclose(file_stream);
	return 0;
}
